VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsFilesExpl"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' -------------------------------------------------------------------------
' Filename:     ExplClsF.Cls
' Project:      Generic Explorer
'
' Purpose:      This is ...
'
' -------------------------------------------------------------------------
' Revisions
'
' -------------------------------------------------------------------------
Option Explicit

' -------------------------------------------------------------------------
'Purpose:   ?
'Inputs:    ?:   ?
'Assumes:   ?
'Effects:   ?
' -------------------------------------------------------------------------
Public Function pLoadTreeFamily(rTvw As TreeView, ByVal vsNodeProxy As String) As Boolean ' once only
    Dim objRootNode As Node
    Dim objTopNode As Node
    Dim objTreeNode As Node
    Set objRootNode = rTvw.Nodes.Item(rTvw.Tag & gsKEYLVL_ROOT & gsKEYTYP_ROOT & gsKEYIDX_ZERO & gsKEYNAME_ROOT)
    Set objTopNode = rTvw.Nodes.Add(objRootNode, tvwChild, _
        rTvw.Tag & gsKEYLVL_FAMILY & gsKEYTYP_DISK & gsKEYIDX_ZERO & gsKEYNAME_DISK, _
        gsKEYNAME_DISK, giIMG_MYCOMPUTER)
    ' Add placeholder node (used initially below family node to allow fast startup)
    Set objTreeNode = rTvw.Nodes.Add(objTopNode, tvwChild, _
        rTvw.Tag & gsKEYLVL_TREE & gsKEYTYP_DISK & gsKEYIDX_ZERO & gsKEYNAME_DISK & vsNodeProxy, _
        vsNodeProxy, giIMG_RAMDRIVE)
End Function

Public Sub pGetColumnHeaders(ByVal vLevel As String, rHeaderNames() As String, rDefaultHeaderWidths() As Long, rlHdrAlignments() As Long)
    ReDim rHeaderNames(4)
    ReDim rDefaultHeaderWidths(4)
    ReDim rlHdrAlignments(4)
    rHeaderNames(0) = "Name"
    rHeaderNames(1) = "Type"
    rHeaderNames(2) = "Size"
    rHeaderNames(3) = "Date"
    rDefaultHeaderWidths(0) = 1800
    rDefaultHeaderWidths(1) = 1000
    rDefaultHeaderWidths(2) = 1000
    rDefaultHeaderWidths(3) = 1800
    rlHdrAlignments(0) = lvwColumnLeft
    rlHdrAlignments(1) = lvwColumnLeft
    rlHdrAlignments(2) = lvwColumnRight
    rlHdrAlignments(3) = lvwColumnRight
End Sub

Public Function pEnableMenuItems(rmnuDelete As Menu, rmnuRename As Menu, rmnuUndo As Menu, rmnuFind As Menu, rmnuSelect As Menu)
    rmnuDelete.Enabled = True
    rmnuRename.Enabled = True
    rmnuUndo.Enabled = True
    rmnuFind.Enabled = True
    rmnuSelect.Enabled = True
End Function

Public Function pLoadMenuFileNewItems(rmnuCreateNames() As String) As Boolean 'rmnuFileExtraArray() as menu
    ReDim rmnuCreateNames(2)
    rmnuCreateNames(0) = "File"
    rmnuCreateNames(1) = "Dir"
    pLoadMenuFileNewItems = True
End Function
Public Function pLoadTreeViewBranches(rNode As Node, ByVal vsNodeLevel As String, ByVal vsNodeName As String, rTvw As TreeView, rbLoadCancel As Boolean) As Boolean
    Dim nodChild As Node
    Select Case vsNodeLevel
    Case gsKEYLVL_FAMILY    ' Top-level "Disk Drives"
            Call loadLocalDrives(rTvw, rNode, False)
    Case gsKEYLVL_TREE, gsKEYLVL_BRANCH      ' Child disk or directory
        Call loadLocalDirList(rTvw, rNode, vsNodeName, False)
        Set nodChild = rNode.Child
        Do While Not nodChild Is Nothing
        ' if rbloadcancel then ???
            Call loadLocalDirList(rTvw, nodChild, vsNodeName & "\" & nodChild.Text, True)
            Set nodChild = nodChild.Next
        Loop
    End Select
    pLoadTreeViewBranches = True ' sort node list
End Function

Private Sub Class_Initialize()
    ' set default values for column widths???
End Sub


' -------------------------------------------------------------------------
'Purpose:   ?
'Inputs:    ?:   ?
'Assumes:   ?
'Effects:   ?
' -------------------------------------------------------------------------
Private Sub loadLocalDrives(rTvw As TreeView, nodParent As Node, rFirstOnly As Boolean)
    Dim lDrive As Long                               ' Drive ID
    Dim sDrive As String * 1                         ' Drive Letter
    Dim lDriveType As Long                           ' Drive Type Icon Value
    Dim sNewNodeName As String                       ' New Child Node
    Dim nodNew As Node
    Dim i As Integer

    On Error Resume Next
    For lDrive = Asc("A") To Asc("Z")                ' For Each Drive Letter
        sDrive = Chr$(lDrive)                        ' Convert Drive ID To String
        sNewNodeName = rTvw.Tag & gsKEYLVL_TREE & gsKEYTYP_DISK & gsKEYIDX_ZERO & sDrive & ":"
        If getDriveInfo(sDrive, lDriveType) Then     ' Get Drive Type Icon Value
            Set nodNew = rTvw.Nodes.Add(nodParent, tvwChild, _
                sNewNodeName, sDrive & ":", lDriveType)   ' Add Node To Tree...
            i = (i + 1) Mod 4
            If i = 0 Then rTvw.Refresh
            If Not nodNew Is Nothing Then Call loadLocalDirList(rTvw, nodNew, nodNew.Text, True)
            If rFirstOnly Then Exit Sub
        End If
    Next lDrive
End Sub

' -------------------------------------------------------------------------
'Purpose:   ?
'Inputs:    ?:   ?
'Assumes:   ?
'Effects:   ?
' -------------------------------------------------------------------------
Private Function getDriveInfo(ByVal vsDrvLetter As String, rDrvType As Long) As Boolean
    Dim sDrive As String
    sDrive = vsDrvLetter & ":\"
    getDriveInfo = False                ' Set Default Return Code
    Select Case GetDriveType(sDrive)    ' Windows API call
    Case DRIVE_CDROM
        rDrvType = giIMG_CDROMDRIVE
    Case DRIVE_FIXED
        rDrvType = giIMG_HARDDRIVE
    Case DRIVE_REMOTE
        rDrvType = giIMG_NETDRIVE
    Case DRIVE_RAMDISK
        rDrvType = giIMG_RAMDRIVE
    Case DRIVE_REMOVABLE
        rDrvType = giIMG_FLOPPY35
    Case Else
        Exit Function
    End Select
    getDriveInfo = True
End Function


' -------------------------------------------------------------------------
'Purpose:   ?
'Inputs:    ?:   ?
'Assumes:   ?
'Effects:   ?
'Comments:  This procedure must not be called recursively because of the
'           use of the Dir$() function which cannot have more than one
'           active context stream
' -------------------------------------------------------------------------
Private Sub loadLocalDirList(rTvw As TreeView, rNode As Node, ByVal vsNodeName As String, bFirstOnly As Boolean)
    Dim sRootDir As String                          ' Root Directory Of SubDirectory
    Dim sChildDir As String                         ' New Child Directory
    Dim iAttr As Integer                             ' File Attributes Var...
    Dim objNext As Object

    On Error GoTo CheckError                        ' Enable Error Handler
    With rTvw.Nodes                                 ' Shorten Ole Reference...
        sRootDir = vsNodeName
        sRootDir = sRootDir & "\"                     ' Add Directory Separator
        sChildDir = Dir$(sRootDir, vbDirectory)       ' Start Search For Sub Directories
        Do While (sChildDir <> "")                   ' While More Directories
            If ((sChildDir <> ".") And (sChildDir <> "..")) Then ' Ignore Current and Previous Directories...
                iAttr = GetAttr(sRootDir & sChildDir)      ' Extract Attributes...
                If ((iAttr And vbDirectory) = vbDirectory) Then            ' Is This A Directory...
                    Set objNext = .Add(rNode.Key, tvwChild, _
                              rTvw.Tag & gsKEYLVL_BRANCH & gsKEYTYP_DISK & gsKEYIDX_ZERO & sRootDir & sChildDir, _
                              sChildDir, giIMG_FOLDERCLOSED) ' Add New Directory Node To Tree.
                    DoEvents
                    If bFirstOnly Then Exit Sub
                End If
            End If
            sChildDir = Dir$                         ' Get Next Directory
        Loop                                        ' Loop For More Directories...
    End With ''' rTvw.Nodes

    Exit Sub
'------------------------------------------------------------
CheckError:
'------------------------------------------------------------
    ' "Expected" errors:
    ' error 71 disk not ready
    ' error 76 path not found
    ' error 52 bad file name or number
    ' error 5 invalid procedure call
    Resume Next     ' Ignore Error And Resume..
'------------------------------------------------------------
End Sub


Public Function pLoadListViewBranchesAndLeaves(rNode As Node, ByVal vsThisNodeLevel As String, ByVal vsThisNodeName As String, rTvw As TreeView, rLvw As ListView, rbLoadCancel As Boolean, riColSort As Integer) As Boolean
    Dim sPath As String
    Dim sFile As String
    Dim sFullFileName As String
    Dim i As Integer
    Dim iAttr As Integer
    Dim Row As Object
    Dim tmpdate As Date

    Select Case vsThisNodeLevel
    Case gsKEYLVL_FAMILY
        Dim nodChild As Node
        Set nodChild = rNode.Child
        Do While Not nodChild Is Nothing
            Set Row = rLvw.ListItems.Add(, nodChild.Key, nodChild.Text & " Drive", nodChild.Image, nodChild.Image) ' nodChild.SelectedImage)
            Set nodChild = nodChild.Next
        Loop
        riColSort = 1   ' set sort column (Name)
    Case Else
        On Error GoTo CheckError
        sPath = vsThisNodeName
        sFile = Dir$(sPath & "\", vbNormal + vbReadOnly + vbHidden + _
                    vbSystem + vbArchive + vbDirectory) ' Get First File Name
        Do While (sFile <> "")                       ' While More Files Exist...
            If ((sFile <> ".") And (sFile <> "..")) Then
                sFullFileName = sPath & "\" & sFile ' Copy Full File Name
                iAttr = GetAttr(sFullFileName)            ' Get Files Attributes...
                If (iAttr <> vbDirectory) Then
                    ' Add File Name To ListView
                    Set Row = rLvw.ListItems.Add(, rTvw.Tag & gsKEYLVL_LEAF & gsKEYTYP_DISK & gsKEYIDX_ZERO & sFullFileName, sFile, giIMG_FILE, giIMG_FILE)
                    Row.SubItems(1) = "File" ' Add Type To ListView
                Else
                    ' Add Directory Name To ListView
                    Set Row = rLvw.ListItems.Add(, rTvw.Tag & gsKEYLVL_BRANCH & gsKEYTYP_DISK & gsKEYIDX_ZERO & sFullFileName, sFile, giIMG_FOLDERCLOSED, giIMG_FOLDERCLOSED)
                    Row.SubItems(1) = "Directory" ' Add Type To ListView
                End If
                ' Add File Size To ListView
                Row.SubItems(2) = Format$(Format$((FileLen(sFullFileName) \ 1024), "##,###,##0") & "KB", "@@@@@@@@@@@@")
                ' Add File Date/Time To ListView
                tmpdate = FileDateTime(sFullFileName)
                Row.SubItems(3) = Format$(tmpdate, "Medium Date") & " " & Format$(tmpdate, "Medium Time")
                Row.Tag = Format$(tmpdate, "0000000.0000000000")
                If i = 0 Then
                    rLvw.Refresh
                    DoEvents
                End If
                i = (i + 1) Mod 120
            End If
            sFile = Dir$                              ' Get Next File
        Loop
        riColSort = 2   ' set sort column (Type)
    End Select
    Exit Function
'------------------------------------------------------------
CheckError:
'------------------------------------------------------------
    iAttr = 0
    Resume Next     ' Ignore Error And Resume..
'------------------------------------------------------------
End Function

Public Sub pShowProperties(ByVal vsThisNodeLevel As String, roLastActiveView As Object, rTvw As TreeView, rLvw As ListView, ByVal vbReadOnly As Boolean)
    frmFilesProperties.LoadObjects(rTvw) = rLvw
    Call frmFilesProperties.ShowMe
End Sub

